import java.io.*;
import java.util.*;


public class Hauptprogramm
{
    private int    puck_anzahl = 10;
    private double t  = 0.0;
    private double dt = 0.1;
    private int schritte = 10000;
    public Modell[] modell;
    public Integrator[] integrator;

    private int iabs(int x)
    {
        if(x<0)
            return -x;
        else
            return x;
    }

    public void init()
    {
        //Erzeugen aller Modelle
        modell = new Modell[puck_anzahl];
        for(int i=0;i<puck_anzahl;i++)
            modell[i] = new Modell(modell);

        Random random = new Random(0);

        //Zufllige Anfangsbedingungen fr die Pucks setzen:
        for(int i=0;i<puck_anzahl;i++)
        {
            modell[i].yalt[0] =  (double)(50 + iabs(random.nextInt())%400);
            modell[i].yalt[1] =  0.001*(double)(iabs(random.nextInt())%2000 - 1000);
            modell[i].yalt[2] =  (double)(50 + iabs(random.nextInt())%400);
            modell[i].yalt[3] =  0.001*(double)(iabs(random.nextInt())%2000 - 1000);
        }

        //Erzeugen der zugehrigen Integratoren
        integrator = new Integrator[puck_anzahl];
        for(int i=0;i<puck_anzahl;i++)
            integrator[i] = new Integrator(modell[i]);
    }

    public void simulieren()
    {
        for(int i=0;i<schritte;i++)
        {
            System.out.print(""+t);
            for(int k=0;k<puck_anzahl;k++)
            {
                //Fr Scilab Zeit und dann alle Koordinaten zeilenweise ausgeben
                System.out.print(" "+modell[k].yalt[0]+" "+modell[k].yalt[2]);
                integrator[k].zeitschritt(t,dt);
            }
            //alle neuen Zustaende als alte umkopieren vorbereitend auf den nchsten Integrationsschritt:
            for(int ii=0;ii<puck_anzahl;ii++) //alle Pucks durchgehen
            {
                for(int k=0;k<modell[ii].yneu.length;k++)
                    modell[ii].yalt[k] = modell[ii].yneu[k];
            }
            System.out.println();
            t+=dt;
        }
    }

    public static void main(String[] args)
    {
        Hauptprogramm hp = new Hauptprogramm();
        hp.init();
        hp.simulieren();
    }
}