public class Modell
{
    public Modell[] puck;

    public static int zaehler=0; //Zhlt wieviele Pucks bereits erzeugt wurden.

    public int nr; //Nummer des aktuellen Pucks 

    public double[] param = {1.0,0.001,30.0,20.0};

    public double[] yalt; //Im Modell den letzten Zustand merken
    public double[] yneu; //Vernderten Zustand innerhalb eines Zeitschritts auch merken.

    private int anzahl=4;
    private  double m;
    private  double D;
    private  double K;
    public   double R; //Puckradius
    
    private double f;

    public Modell(Modell[] puck)  
    {  
        this.puck = puck; //Alle Pucks in jedem Puck-Objekt registrieren.

        yalt = new double[anzahl];      
        yneu = new double[anzahl];      
        nr=zaehler;  //Aktuell erstelltem Puck eine Nummer zuweisen.
        zaehler++;   //In statischer Variablen mitzaehlen, wieviele Pucks schon erstellt wurden.
    }

    public double rechteSeite(double[] y,double t, int zeile)
    {
        m = param[0];
        D = param[1];
        K = param[2];
        R = param[3];

        //Durch Kollisionen entstehende Zusatzkraft bestimmen.
        //Alle anderen Pucks durchgehen.
        double x_koll=0.0;
        double y_koll=0.0;

        for(int i=0;i<puck.length;i++)
        {
            if(i!=nr) //nur wenn Auswahl nicht aktueller Puck selbst ist.
            {
                double x1 = yalt[0];
                double y1 = yalt[2];
                double x2 = puck[i].yalt[0];
                double y2 = puck[i].yalt[2];

                double betrag = Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)); //Distanz der Puck-Mittelpunkte nr und i

                if(betrag<2.0*R && betrag!=0.0)
                {
                    //Richtungsvektor bestimmen:
                    double ex = (x1-x2)/betrag;
                    double ey = (y1-y2)/betrag;

                    //Kraft hinzuaddieren:
                    x_koll += K*(2.0*R-betrag)*ex;
                    y_koll += K*(2.0*R-betrag)*ey;
                }
            }
        }

        switch(zeile)
        {
            case 0:
                f = y[1];
            break;
            case 1:
                f = -(D/m)*y[1]+x_koll/m; 
            break;                    
            case 2:
                f = y[3];
            break;                    
            default:
                f = -(D/m)*y[3]+y_koll/m; 
            break;                                                                                            
        }              
        return f; 
    }
    public int holeAnzahlGleichungen()
    {
        return anzahl;
    } 
} 
