import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;


public class Hauptprogramm extends Applet implements Runnable
{

//Fr Animation bentigte Attribute:
    public Thread thread;

    public Frame fenster;
    public Image puffer = null;
    public Graphics grafikpuffer;

//Fr Simulation bentigte Attribute:
    private int    puck_anzahl = 10;
    private double t  = 0.0;
    private double dt = 0.1;
    private int schritte = 10000;
    public Modell[] modell;
    public Integrator[] integrator;

    
    private int iabs(int x)
    {
        if(x<0)
            return -x;
        else
            return x;
    }

    public void init()
    {
        //Erzeugen aller Modelle
        modell = new Modell[puck_anzahl];
        for(int i=0;i<puck_anzahl;i++)
            modell[i] = new Modell(modell);

        Random random = new Random(0);

        //Zufllige Anfangsbedingungen fr die Pucks setzen:
        for(int i=0;i<puck_anzahl;i++)
        {
            modell[i].yalt[0] =  (double)(50 + iabs(random.nextInt())%400);
            modell[i].yalt[1] =  0.01*(double)(iabs(random.nextInt())%2000 - 1000);
            modell[i].yalt[2] =  (double)(50 + iabs(random.nextInt())%400);
            modell[i].yalt[3] =  0.01*(double)(iabs(random.nextInt())%2000 - 1000);
        }

        //Erzeugen der zugehrigen Integratoren
        integrator = new Integrator[puck_anzahl];
        for(int i=0;i<puck_anzahl;i++)
            integrator[i] = new Integrator(modell[i]);


        //Animation:
        thread = new Thread(this);
        if(puffer==null)
        {
            puffer = createImage(500,500);
            if(puffer!=null)
                grafikpuffer = puffer.getGraphics();
        }
    }

    public void start()
    {
        thread.start();
    }

    public void run()
    {
        while(true)
        {
            //System.out.print(""+t);
            for(int k=0;k<puck_anzahl;k++)
            {
                //Fr Scilab Zeit und dann alle Koordinaten zeilenweise ausgeben
                //System.out.print(" "+modell[k].yalt[0]+" "+modell[k].yalt[2]);
                integrator[k].zeitschritt(t,dt);
            }
            //alle neuen Zustaende als alte umkopieren vorbereitend auf den nchsten Integrationsschritt:
            for(int ii=0;ii<puck_anzahl;ii++) //alle Pucks durchgehen
            {
                for(int k=0;k<modell[ii].yneu.length;k++)
                    modell[ii].yalt[k] = modell[ii].yneu[k];
            }
            //System.out.println();
            t+=dt;
 


            try
            {
                Thread.sleep(10);
            }
            catch(Exception e)
            {
            }
 
            if(puffer==null)
            {
                puffer = createImage(500,500);
                if(puffer!=null)
                    grafikpuffer = puffer.getGraphics();
            }
            if(puffer!=null)
            {
                paintNeu(grafikpuffer);
                repaint();
            }
        }
    }

    public void paintNeu(Graphics g)
    {
      g.setColor(new Color(255,255,255));
      g.fillRect(0,0,500,500);

      for(int i=0;i<puck_anzahl;i++)
      {
        g.setColor(new Color(i*10,255-i*10,200));
        int x = (int)(modell[i].yalt[0]-modell[i].R);
        int y = (int)(modell[i].yalt[2]-modell[i].R);
        g.fillOval(x,y,(int)(2.0*modell[i].R),(int)(2.0*modell[i].R));
      }
    }

    public void paint(Graphics g)
    {
        if(puffer!=null)
            g.drawImage(puffer,0,0,null);
    }


    public static void main(String[] args)
    {

        Hauptprogramm hb = new Hauptprogramm();

        hb.init();
        hb.start();
        hb.repaint();

        JFrame mF = new JFrame("Differentialgeometrie");
        mF.getContentPane().add(hb);
        mF.pack();
        mF.setSize(500,500);
        mF.setLocation(10,10);
        mF.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mF.setVisible(true);
    }
}
